
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Qa_resultsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.create(
            {
                id: data.id || undefined,
        
        numeric_value: data.numeric_value
        ||
        null
            ,
            
        attribute_value: data.attribute_value
        ||
        null
            ,
            
        result: data.result
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        comment: data.comment
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await qa_results.setInspection( data.inspection || null, {
            transaction,
        });
        
        await qa_results.setCharacteristic( data.characteristic || null, {
            transaction,
        });
        
        await qa_results.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return qa_results;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const qa_resultsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                numeric_value: item.numeric_value
            ||
            null
            ,
            
                attribute_value: item.attribute_value
            ||
            null
            ,
            
                result: item.result
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                comment: item.comment
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const qa_results = await db.qa_results.bulkCreate(qa_resultsData, { transaction });

        // For each item created, replace relation files
        

        return qa_results;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const qa_results = await db.qa_results.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.numeric_value !== undefined) updatePayload.numeric_value = data.numeric_value;
        
        
        if (data.attribute_value !== undefined) updatePayload.attribute_value = data.attribute_value;
        
        
        if (data.result !== undefined) updatePayload.result = data.result;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.comment !== undefined) updatePayload.comment = data.comment;
        
        
        updatePayload.updatedById = currentUser.id;

        await qa_results.update(updatePayload, {transaction});

        
        
        if (data.inspection !== undefined) {
            await qa_results.setInspection(
              
              data.inspection,
              
              { transaction }
            );
        }
        
        if (data.characteristic !== undefined) {
            await qa_results.setCharacteristic(
              
              data.characteristic,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await qa_results.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return qa_results;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of qa_results) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of qa_results) {
                await record.destroy({transaction});
            }
        });


        return qa_results;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findByPk(id, options);

        await qa_results.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await qa_results.destroy({
            transaction
        });

        return qa_results;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findOne(
            { where },
            { transaction },
        );

        if (!qa_results) {
            return qa_results;
        }

        const output = qa_results.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inspection = await qa_results.getInspection({
            transaction
        });
        
        
        output.characteristic = await qa_results.getCharacteristic({
            transaction
        });
        
        
        output.organizations = await qa_results.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.qa_inspections,
        as: 'inspection',
        
        where: filter.inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              notes: {
                [Op.or]: filter.inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.qa_characteristics,
        as: 'characteristic',
        
        where: filter.characteristic ? {
          [Op.or]: [
            { id: { [Op.in]: filter.characteristic.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.characteristic.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.unit) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_results',
                        'unit',
                        filter.unit,
                    ),
                };
            }
            
            if (filter.comment) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_results',
                        'comment',
                        filter.comment,
                    ),
                };
            }
            

            
            

            
            if (filter.numeric_valueRange) {
                const [start, end] = filter.numeric_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    numeric_value: {
                    ...where.numeric_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    numeric_value: {
                    ...where.numeric_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.attribute_value) {
                where = {
                    ...where,
                attribute_value: filter.attribute_value,
            };
            }
            
            if (filter.result) {
                where = {
                    ...where,
                result: filter.result,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.qa_results.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'qa_results',
                        'comment',
                        query,
                    ),
                ],
            };
        }

        const records = await db.qa_results.findAll({
            attributes: [ 'id', 'comment' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comment', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comment,
        }));
    }

    
};

